VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCFG"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''
' ARCADE QUAKE LAUNCHER
' :  . , pauk.vortex@gmail.com
' -    
''''''''''''''''''''''''''''''''''''''''

Public Options As clsOPT

'  
Private Sub Class_Initialize()
    Set Options = New clsOPT

    ' register options
    With Options
        .ListAdd "engine", _
                 Array("Darkplaces", "Darkplaces SDL"), _
                 Array("darkplaces.exe", "darkplaces-sdl.exe")
        .ListAdd "vid_width", _
                 Array("< Resolution >", "640x480", "800x600", "960x720", "1024x768", "1280x960", "1600x1200"), _
                 Array("", "640", "800", "960", "1024", "1280", "1600")
        .ListAdd "vid_samples", _
                 Array("2X", "4X", "8X"), _
                 Array("2", "4", "8")
        .ListAdd "screenmode", _
                Array("Fullscreen", "Windowed"), _
                Array("-fullscreen", "-window +vid_pixelheight 1")
        .Add "Options", "engine", "darkplaces.exe"
        .Add "Options", "makelog", "0"
        .Add "Options", "developer", "0"
        .Add "Options", "usecmdline", "0"
        .Add "Options", "cmdline", ""
        .Add "Options", "vid_width", ""
        .Add "Options", "antialiasing", "0"
        .Add "Options", "vid_samples", "2"
        .Add "Options", "screenmode", "-fullscreen"
        .Add "Options", "usedinput", "0"
        .Add "Options", "vid_custom", "0"
        .Add "Options", "vid_customwidth", "1024"
        .Add "Options", "vid_customheight", "768"
        .Add "Options", "vid_custombpp", "32"
        .Add "Options", "vid_customaspectx", ""
        .Add "Options", "vid_customaspecty", ""
        .Add "Options", "vid_custompixelheight", ""
        .Add "Options", "vid_customrefreshrate", ""
        .Add "Options", "vid_customsamples", ""
        .Add "SafeMode", "safemode", "0"
        .Add "SafeMode", "noaa", "0"
        .Add "SafeMode", "nodirectsound", "0"
        .Add "SafeMode", "novbo", "0"
        .Add "SafeMode", "noearlystencil", "0"
        .Add "SafeMode", "nodre", "0"
        .Add "SafeMode", "nocva", "0"
        .Add "SafeMode", "notex3d", "0"
        .Add "SafeMode", "noshaders", "0"
        .Add "SafeMode", "nocubemap", "0"
        .Add "SafeMode", "noseparatestencil", "0"
        .Add "SafeMode", "nostenciltwoside", "0"
        .Add "SafeMode", "nocombine", "0"
        .Add "SafeMode", "nodot3", "0"
        .Add "SafeMode", "noec", "0"
        .Add "SafeMode", "nomtex", "0"
        .Add "SafeMode", "windowed", "0"
        .Add "SafeMode", "noaniso", "0"
        .Add "SafeMode", "notexnonpoweroftwo", "0"
        .Add "SafeMode", "notexcompression", "0"
    End With
    Reset
End Sub

'      -
Public Sub InitComboList(ByRef Combo As ComboBox, ByVal tKey As String)
    Dim tPos As Integer
    Dim tArrayOfValues() As Variant
    Dim tCount As Integer
    
    Combo.Clear
    tCount = Options.ListGetCount(tKey)
    If (tCount > 0) Then
        tArrayOfValues = Options.ListGetNames(tKey)
        For tPos = 0 To tCount - 1
            Combo.AddItem tArrayOfValues(tPos), tPos
        Next tPos
    End If
End Sub

'   
Public Function MakeCommandLine() As String
    Dim tParm As String
    
    ' engine
    MakeCommandLine = Options.GetString("engine") & " -game arcade"
    ' custom resulution
    If (Options.GetBoolean("vid_custom") <> False) Then
        tParm = Options.GetString("vid_customwidth")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " -width " & tParm
        Else
            tParm = Options.GetString("vid_width")
            If (tParm <> "") Then
                MakeCommandLine = MakeCommandLine & " -width " & tParm
            End If
        End If
        tParm = Options.GetString("vid_customheight")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " -height " & tParm
        End If
        tParm = Options.GetString("vid_custombpp")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " -bpp " & tParm
        End If
        tParm = Options.GetString("vid_custompixelheight")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " -vid_pixelheight " & tParm
        End If
        tParm = Options.GetString("vid_customrefreshrate")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " -vid_userefreshrate 1 -vid_refreshrate " & tParm
        End If
    Else
        tParm = Options.GetString("vid_width")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " -width " & tParm
        End If
        If (Options.GetBoolean("safemode") = False Or Options.GetBoolean("noaa") = False) Then
            If (Options.GetBoolean("antialiasing") = True) Then
                tParm = Options.GetString("vid_samples")
                If (tParm <> "") Then
                    MakeCommandLine = MakeCommandLine & " +vid_samples " & tParm
                End If
            End If
        End If
    End If
    ' windowed or fullscreen
    If (Options.GetBoolean("safemode") = False Or Options.GetBoolean("windowed") = False) Then
        tParm = Options.GetString("screenmode")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " " & tParm
        End If
    End If
    ' make log
    If (Options.GetBoolean("makelog") = True) Then
        MakeCommandLine = MakeCommandLine & " -condebug"
       End If
    ' developer mode
    If (Options.GetBoolean("developer") = True) Then
        MakeCommandLine = MakeCommandLine & " -developer"
    End If
    ' use direct input
    If (Options.GetBoolean("usedinput") = True) Then
        MakeCommandLine = MakeCommandLine & " -dinput"
    End If
    ' cmd line
    If (Options.GetBoolean("nocmdline") = False) Then
        tParm = Options.GetString("cmdline")
        If (tParm <> "") Then
            MakeCommandLine = MakeCommandLine & " " & tParm
        End If
    End If
    If (Options.GetBoolean("safemode") = True) Then
        ' no direct sound
        If (Options.GetBoolean("nodirectsound") = True) Then
            MakeCommandLine = MakeCommandLine & " -wavonly"
        End If
        ' no antialias
        If (Options.GetBoolean("noaa") = True) Then
            MakeCommandLine = MakeCommandLine & " +vid_samples 1"
        End If
        ' no vbo
        If (Options.GetBoolean("novbo") = True) Then
            MakeCommandLine = MakeCommandLine & " -novbo"
        End If
        ' no early stencil
        If (Options.GetBoolean("noearlystencil") = True) Then
            MakeCommandLine = MakeCommandLine & " +r_depthfirst 0"
        End If
        ' no drawrangeelements
        If (Options.GetBoolean("nodre") = True) Then
            MakeCommandLine = MakeCommandLine & " -nodrawrangeelements"
        End If
        ' no compiledvertexarray
        If (Options.GetBoolean("nocva") = True) Then
            MakeCommandLine = MakeCommandLine & " -nocva"
        End If
        ' no texture3d
        If (Options.GetBoolean("notex3d") = True) Then
            MakeCommandLine = MakeCommandLine & " -notexture3d"
        End If
        ' no shaders
        If (Options.GetBoolean("noshaders") = True) Then
            MakeCommandLine = MakeCommandLine & " -noshaderobjects -noshadinglanguage100 -novertexshader -nofragmentshader"
        End If
        ' no cubemap
        If (Options.GetBoolean("nocubemap") = True) Then
            MakeCommandLine = MakeCommandLine & " -nocubemap"
        End If
        ' no separatestencil
        If (Options.GetBoolean("noseparatestencil") = True) Then
            MakeCommandLine = MakeCommandLine & " -noseparatestencil"
        End If
        ' no separatestencil
        If (Options.GetBoolean("nostenciltwoside") = True) Then
            MakeCommandLine = MakeCommandLine & " -nostenciltwoside"
        End If
        ' no combine
        If (Options.GetBoolean("nocombine") = True) Then
            MakeCommandLine = MakeCommandLine & " -nocombine"
        End If
        ' no dot3
        If (Options.GetBoolean("nodot3") = True) Then
            MakeCommandLine = MakeCommandLine & " -nodot3"
        End If
        ' no edgeclamp
        If (Options.GetBoolean("noec") = True) Then
            MakeCommandLine = MakeCommandLine & " -noedgeclamp"
        End If
        ' no multitexture
        If (Options.GetBoolean("nomtex") = True) Then
            MakeCommandLine = MakeCommandLine & " -nomtex"
        End If
        ' no anisotropy
        If (Options.GetBoolean("noaniso") = True) Then
            MakeCommandLine = MakeCommandLine & " -noanisotropy"
        End If
        ' no texture_non_power_of_two
        If (Options.GetBoolean("notexnonpoweroftwo") = True) Then
            MakeCommandLine = MakeCommandLine & " -notexturenonpoweroftwo"
        End If
        ' no texture compression
        If (Options.GetBoolean("notexcompression") = True) Then
            MakeCommandLine = MakeCommandLine & " -notexturecompression"
        End If
        ' force windowed
        If (Options.GetBoolean("windowed") = True) Then
            MakeCommandLine = MakeCommandLine & " -window +vid_pixelheight 1"
        End If
    End If
End Function

'  
Public Sub Load()
    Options.LoadAll App.Path & "\launch.ini"
End Sub

'  
Public Sub Save()
    Options.SaveAll App.Path & "\launch.ini"
End Sub

'  
Public Sub Reset()
    Options.ResetAll
End Sub




